declare namespace Mqtt {
  interface Auth {
    id: number;
    client_id: string | null;
    mount_point: string | null;
    user_name: string;
    password: string;
    pasture_id: number | null;
    pasture_name: string | null;
    pub_topic_id: number | null;
    sub_topic_id: number | null;
    access: number | null;
    publish_acl: string | null;
    subscribe_acl: string | null;
    created_at_format: string | null;
    updated_at_format: string | null;
    pub_topic_ids: [] | null;
    sub_topic_ids: [] | null;
    key: number;
  }

  interface AuthData {
    page: number;
    page_size: number;
    list: Auth[];
    count: number;
  }

  interface SearchAuth {
    pasture_name: string;
    user_name: string;
    pub_topic_name: string;
    sub_topic_name: string;
  }

  interface User {
    id: number;
    user_name: string | null;
    password: string;
    client_id: string | null;
    pasture_id: number | null;
    topic_ids: string | null;
    is_show: number | null;
    access: number | null;
    created_at_format: string | null;
    updated_at_format: string | null;
  }

  interface Topic {
    id: number;
    pasture_id: number | null;
    pasture_name: string | null;
    topic_name: string | null;
    topic_template: string | null;
    access: number | null;
    is_show: number | null;
    created_at_format: string | null;
    updated_at_format: string | null;
    key: number;
  }

  interface TopicData {
    page: number;
    page_size: number;
    list: Topic[];
    count: number;
  }

  interface Pasture {
    id: number;
    pasture_name: string | null;
    short_name: string | null;
    is_show: number | null;
    created_at_format: string | null;
    updated_at_format: string | null;
    key: number;
  }

  interface PastureData {
    page: number;
    page_size: number;
    list: Pasture[];
    count: number;
  }

  interface Category {
    id: number;
    name: string | null;
    is_show: number | null;
    created_at_format: string | null;
    updated_at_format: string | null;
  }
}
